-- cgia.e = cgi sederhana
include aku.e

object qs, xnama, xisi, lenq

function persen(object st)
	st = ganti(st, "+", " ")
	for i = #00 to #FF do
		if i = '%' then
			st = ganti(st, "%" & sprintf("%02x", i), "%"+#100)
		else
			st = ganti(st, "%" & sprintf("%02x", i), {i})
		end if
	end for
	st = ganti(st, "%"+#100, "%")
	return st
end function

procedure parse()
object data
	if atom(qs) or length(qs)=0 then
		xnama = {}
		xisi = {}
		return
	end if
	data = pisah(qs, '&')
	xnama = repeat(0, length(data))
	xisi = repeat(0, length(data))
	for i = 1 to length(data) do
		data[i] = pisah(data[i], '=')
		xnama[i] = persen(data[i][1])
		xisi[i] = persen(data[i][2])
	end for
end procedure

global procedure ambilGet()
	qs = getenv("QUERY_STRING")
	if atom(qs) or length(qs) < 1 then
		qs = command_line()
		if length(qs) >= 3 then
			qs = depisah(qs[3..length(qs)], ' ')
		else
			qs = ""
		end if
	end if
	parse()
end procedure


global procedure ambilPost()
	lenq = getenv("CONTENT_LENGTH")
	if atom(lenq) or length(lenq) < 1 then
		qs = no10(gets(0))
	else
		qs = get_bytes(0, val(lenq))
	end if
	parse()
end procedure


global function ambilNilai(object nama)
object pos
	pos = find(nama, xnama)
	if pos = 0 then
		pos = find(lower(nama), lower(xnama))
	end if
	if pos = 0 then
		return -1
	end if
	return xisi[pos]
end function

global function ambilXnama()
	return xnama
end function



global procedure tulisHeader()
	puts(1, "Content-type: text/html\n\n")
end procedure


